//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// プリンタポート
//

#include "printer.h"
#include "mpu.h"

// グローバル参照用
PrinterDevice *gPrinter;

// コンストラクタ
PrinterDevice::PrinterDevice()
	: inherited("Printer")
{
	devaddr = baseaddr;
	devlen  = 0x2000;
}

// デストラクタ
PrinterDevice::~PrinterDevice()
{
	gPrinter = NULL;
}

uint64
PrinterDevice::Read8(uint32 addr)
{
	// 書き込み専用
	gMPU->AddCycle(7);	// InsideOut p.135
	return (uint64)-1;
}

uint64
PrinterDevice::Read16(uint32 addr)
{
	// 書き込み専用
	gMPU->AddCycle(7);	// InsideOut p.135
	return (uint64)-1;
}

uint64
PrinterDevice::Write8(uint32 addr, uint32 data)
{
	gMPU->AddCycle(7);	// InsideOut p.135

	uint32 offset = addr - baseaddr;
	switch (offset) {
	 case 0:
		// データ書き込み
		putlog(0, "Write Data (NOT IMPLEMENTED)");
		break;
	 case 3:
		// ストローブ書き込み
		putlog(0, "Write Strobe (NOT IMPLEMENTED)");
		return 0;
	 default:
		break;
	}
	return (uint64)-1;
}

uint64
PrinterDevice::Write16(uint32 addr, uint32 data)
{
	return Write8(addr + 1, data);
}

uint64
PrinterDevice::Peek8(uint32 addr)
{
	// XXX
	return 0xff;
}
