//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// 3ポート共有 RAM
//

#pragma once

#include "device.h"

class ZRAMDevice : public IODevice
{
	using inherited = IODevice;
 public:
	ZRAMDevice();
	virtual ~ZRAMDevice() override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Read32(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Write32(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;

 private:
	// アドレスデコーダ
	uint64 Decoder(uint32 addr) const;

	std::unique_ptr<uint8[]> ram {};
};

extern ZRAMDevice *gZRAM;
