//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// LUNA LCD パネル
//

#pragma once

#include "wxsubwindow.h"
#include "wxbitmappanel.h"
#include "wxmonitor.h"

// LCD パネル
class WXLCDPanel : public WXBitmapPanel
{
	using inherited = WXBitmapPanel;
 public:
	WXLCDPanel(wxWindow *parent);
	virtual ~WXLCDPanel() override;

 private:
	void OnLCDChanged(wxCommandEvent& event);
	void Draw() override;
	void DrawChar(int x, int y, uint8 ch);

	const uint8 *ddram {};
};

// LCD ウィンドウ
class WXLCDWindow : public WXSubWindow
{
	using inherited = WXSubWindow;
 public:
	WXLCDWindow(wxWindow *parent);
	virtual ~WXLCDWindow() override;

 private:
	WXLCDPanel *panel {};
};

// LCD キャラクタパネル
class WXLCDCharPanel : public WXBitmapPanel
{
	using inherited = WXBitmapPanel;
 public:
	WXLCDCharPanel(wxWindow *parent);
	virtual ~WXLCDCharPanel() override;

 private:
	void Draw() override;
};

// LCD キャラクタウィンドウ
class WXLCDMonitor : public WXSubWindow
{
	using inherited = WXSubWindow;
 public:
	WXLCDMonitor(wxWindow *parent);
	virtual ~WXLCDMonitor() override;

 private:
	WXMonitorPanel *monpanel {};
	WXLCDCharPanel *chrpanel {};
};
