//
// nono
// Copyright (C) 2022 nono project
// Licensed under nono-license.txt
//

//
// ログレベル設定ウィンドウ
//

#pragma once

#include "wxtextpanel.h"
#include "wxsubwindow.h"

class WXLogSettingPanel : public WXTextPanel
{
	using inherited = WXTextPanel;

	static const int Padding = 3;

 public:
	WXLogSettingPanel(wxWindow *parent);
	~WXLogSettingPanel() override;

	void FontChanged();
	void Draw();

 private:
	inline int Col2PX(int col) const;
	inline int Row2PY(int row) const;
	inline int PX2Col(int px) const;
	inline int PY2Row(int py) const;

	void DrawButton(const Rect& rect, bool button_pressed);
	void OnLeftDown(wxMouseEvent&);
	void OnLeftUp(wxMouseEvent&);

	std::vector<Object *> objs {};

	int maxnamelen {};

	// 押されているボタン
	int pressed {};

	wxDECLARE_EVENT_TABLE();
};

class WXLogSettingWindow : public WXSubWindow
{
	using inherited = WXSubWindow;

 public:
	WXLogSettingWindow(wxWindow *);
	~WXLogSettingWindow() override;

 private:
	WXLogSettingPanel *panel {};
};
