//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// wx 側の共通ヘッダ
//

#pragma once

#include "header.h"
#include "object.h"
#include "wxheader.h"

// ID はグローバルに一意でなければならないのでここで範囲割り当てだけ管理。
//
// monitor_id は自動生成のため ID を 0 から使用する。
// wxmainframe はそのすぐ次から使っていた仕組みを踏襲する。
// それ以外の ID は特に制約なく、適当に割り当てることができる。
enum {
	// monitor_id and
	// wxmainframe
	IDGROUP_MAINFRAME_END = 199,

	// wxdumpmonitor
	IDGROUP_MEMDUMP,
	IDGROUP_MEMDUMP_END = IDGROUP_MEMDUMP + 9,

	// wxplanemonitor
	IDGROUP_PLANEVRAM,
	IDGROUP_PLANEVRAM_END = IDGROUP_PLANEVRAM + 9,
};
